
# 开发文档
如果只是使用标准的xposed功能，那么引入标准xposed依赖即可
```
dependencies {
    compileOnly 'de.robv.android.xposed:api:82'
}
```

如果希望使用ratel提供的扩展api，那么可以选择依赖ratelAPI
```
dependencies {
 compileOnly 'com.virjar:ratel-api:1.0.0'
}
```
请注意，ratel的依赖发布到mavenCentral的。生产环境依赖可以选择
```
repositories {
mavenCentral()
}
```
或者使用阿里云镜像提速
```
    repositories {
        maven {
            name "aliyunmaven"
            url "https://maven.aliyun.com/repository/public"
        }
        maven {
            name "aliyunGoogle"
            url "https://maven.aliyun.com/repository/google"
        }

    }
```

## ratel定制API总线
接口一览
```
package com.virjar.ratel.api;

import android.annotation.SuppressLint;
import android.content.Context;

public class RatelToolKit {
    /**
     * 1。 以下对象，是暴露给调用方的额外API，可以通过他们操作ratel提供的额外功能（除开xposed本身功能之外）
     */
    //全局的一个context，context是调用Android系统功能的重要对象。有这个对象之后，无需手动通过拦截attach的方式获取context
    @SuppressLint("StaticFieldLeak")
    public static Context sContext = null;

    /**
     * ratel框架的配置信息，代表了ratel编码、打包、运行过程产生的一些特定flag
     */
    public static RatelConfig ratelConfig = null;

    /**
     * ratel支持对文件进行重定向
     */
    public static IORelocator ioRelocator = null;

    /**
     * 当前进程名称
     */
    public static String processName = null;

    /**
     * 当成packageName
     */
    public static String packageName = null;


    /**
     * 虚拟化环境功能支持
     */
    public static VirtualEnv virtualEnv = null;

    /**
     * 虚拟化环境下，sdcard将会被隔离，导致无法往sdcard写入数据。但是如果ratel模块期望通过sdcard和其他app交换数据，那么需要通过一个sdcard白名单进行放行
     */
    public static String whiteSdcardDirPath = null;
    /**
     * @hidden
     */
    public static RatalStartUpCallback ratalStartUpCallback = null;

    public static void setOnRatelStartUpCallback(RatalStartUpCallback ratelStartUpCallback) {
        RatelToolKit.ratalStartUpCallback = ratelStartUpCallback;
    }


    /**
     * 2。 以下以下对象，是用户层不需要关心的。我也不会做解释
     */
    public static HookProvider usedHookProvider;

    public static String TAG = null;


}

```